# -*-coding:utf-8 -*- #
# ---------------------------------------------------------------------------
# ProjectName:   pythonProject
# FileName:      request_method.py
# Author:       toast
# Datetime:     2024/9/7 下午2:05
# Description:
# 
# ---------------------------------------------------------------------------
import requests

from apiAutoTest_v3.common.read_project_ini import ReadProjectIni


class RequestMethod:
    def __init__(self):
        login_url = ReadProjectIni().get_host("bpm_host")+"/auth"
        login_data = {"username": "admin", "password": "bF6N3L93cX8pV6x2yEqxNjwIIPaEOYw9bNI5GuIY4g9MeoFyPFPL5WteHaV0LcxQ"
                                                      "qmDJWlhuCRMXzAPvrFcxJrA8BgGjJpmB1WMrQrazIJPbWbCfmDit2s2jzn+DRerV"
                                                      "lYIFojDM96y24drEniwWzHtaJKiWoc7LGL1csNmokvQ="}
        self.bpm_session= requests.sessions.Session()
        res = self.bpm_session.post(url=login_url, json=login_data)
        token = res.json().get("token")
        self.bpm_session.headers["Authorization"] = f"Bearer {token}"

    def request_all(self,req_method,req_url,req_mime,case_data):
        if req_mime == "application/x-www-form-urlencoded" or req_mime == "form":
            return self.bpm_session.request(method=req_method,url=req_url,data=case_data)

        elif req_mime == "application/json" or req_mime == "json":
            return self.bpm_session.request(method=req_method,url=req_url,json=case_data)

        elif req_mime == "multipart/form_data" or req_mime == "form-data":
            return self.bpm_session.request(method=req_method,url=req_url,files=case_data)

        elif req_mime == "query" or req_mime == "params":
            return self.bpm_session.request(method=req_method,url=req_url,params=case_data)

        elif req_mime is None:
            return self.bpm_session.request(method=req_method,url=req_url)

        elif req_mime == "query|json" or req_mime == "json|params":
            return self.bpm_session.request(method=req_method,url=req_url,params=case_data["query"],json=case_data["body"])
